@echo off
setlocal
echo ------------------------------------------------------------------------------------
echo Se va a proceder a la actualizacion del Firmware del mando a distancia.
echo Asegurate de tener el piloto automatico apagado o el dispositvos deconectado de el, 
echo y conectado al ordenador por el cable USB
echo ....................................................................................
echo The firmware update of the remote control will be carried out.
echo Make sure that the autopilot is off or the device is disconnected from it, 
echo and connected to the computer via the USB cable
echo ------------------------------------------------------------------------------------
pause

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo"') do (
    call :resetCOM "%%~J"
)
:continue

echo buscando dispositivo para programar
SET /a v=0
:loop
:: wmic /format:list strips trailing spaces (at least for path win32_pnpentity)
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo bootloader"') do (
    call :setCOM "%%~J"
)
timeout 1
SET /a v+=1
if %v% GTR 5 goto :error
goto :loop
:error
echo error no se pudo localizar tras el reset
goto :fin


:resetCOM <WMIC_output_line>
:: sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo Dispositivo localizado en %port%
pause
mode %port%: BAUD=1200 parity=N data=8 stop=1
goto :continue

:setCOM <WMIC_output_line2>
echo comenzando actualización del firmware en puerto %~1
:: sets _COM#=line
set "passed_point=true"
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo %port%
goto :flash

:flash 
avrdude -Cavrdude.conf -v -patmega32u4 -cavr109 -P%port% -b57600 -D -Uflash:w:firmware13.hex:i
pause
exit
:fin
pause